﻿Shader "Custom/MetaballSurfaceShader"
{
    Properties
    {
        _MainTex ("Albedo", 3D) = "white" {}
        //_BumpMap("Normals", 3D) = "white" {}
        _Glossiness ("Smoothness", Range(0,1)) = 0.5
        _Metallic ("Metallic", Range(0,1)) = 0.0
    }
    SubShader
    {
        Tags { "RenderType"="Opaque" }
        LOD 200

        CGPROGRAM
        // Physically based Standard lighting model, and enable shadows on all light types
        #pragma surface surf Standard fullforwardshadows vertex:vert

        // Use shader model 3.0 target, to get nicer looking lighting
        #pragma target 3.0

        sampler3D _MainTex;
        //sampler3D _BumpMap;

        struct Input
        {
            float2 uv_MainTex;
            float3 objPos;
        };

        half _Glossiness;
        half _Metallic;

        void vert(inout appdata_full v, out Input o) {
            UNITY_INITIALIZE_OUTPUT(Input, o);
            o.objPos = v.vertex;
        }

        void surf (Input IN, inout SurfaceOutputStandard o)
        {
            fixed4 c = tex3D (_MainTex, IN.objPos);
            o.Albedo = c.rgb;
            //fixed4 n = (tex3D(_BumpMap, IN.objPos));
            //o.Normal = n.rgb;
            o.Metallic = _Metallic;
            o.Smoothness = _Glossiness;
            o.Alpha = c.a;
        }
        ENDCG
    }
    FallBack "Diffuse"
}
